;==============================================================================
;
; MSX1 X^[tH[X
;
;	n㕨()BANK4Ɉړ
;	ROM
;
;==============================================================================
include	"obj/StarForce-07a0c.publics"
include	"obj/StarForce-08000.publics"


val_0141_in_rom_03AF	equ	editor

val_00_in_rom_2167		equ	#c3
val_0000_in_rom_2168	equ	enemy_bullet_move


org				#6a28
prog_end	equ	#6ad2




;================================
;	n㕨()Ăяo
;================================
		call	enter_bank_4

		; Xe[W؂ւ
		ld		hl,#e577
		inc		(hl)
		ld		a,(hl)

		; rS[
		di
		call	write_bigora
		ei

		jp		exit_to_bank_0




;================================
;	ROM
;================================
public	rom_init
rom_init:
		; {̏(nCXRA)
		ld     b,#08
		ld     hl,#e3d4
	_lp:
		ld     (hl),#00
		inc    hl
		djnz   _lp

		; F
		ld		hl,bullet_color_tbl
		ld		de,#ee00
		ld		bc,#0010
		ldir
		ld		hl,bg_color_tbl
		ld		de,#ee20
		ld		bc,colors_of_bg
		ldir
		xor		a
		ld		(#ee10),a
		ld		(#ee11),a

		ret



;================================
;	Geړ
;================================
enemy_bullet_move:
		; get current color
		ld		hl,#ee10
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		ld		l,a
		ld		a,(hl)
		ld		ixl,a

		ld		hl,#e54e+#06
		ld		de,#e694+2
		ld		bc,#06ff

		; get current pattern
		ld		a,(de)
		xor		#14 xor #fc
		ld		ixh,a
		ld		e,#94

	_lp:
		ldi
		ld		a,l
		sub		#07
		ld		l,a

		ldi
		ld		a,l
		add		a,#06
		ld		l,a

		; switch pattern
		ld		a,ixh
		ld		(de),a
		inc		e

		; switch color
		ld		a,ixl
		ld		(de),a
		inc		e

		; next
		djnz	_lp
		ret



;================================
;	ҏW[h؂ւ
;================================
editor:
		call	enter_bank_4

		ld		hl,_ret	; ^[AhXZbg
		push	hl

		ld		a,#6
		call	#0141
		bit		5,a
		jp		z,enemy_bullet_editor
		bit		6,a
		jp		z,bg_color_editor
		ld		a,#7
		call	#0141
		bit		0,a
		jp		z,tape_save
		bit		1,a
		jp		z,tape_load

		pop		hl		; ^[AhXNA
	_ret:
		jp		exit_to_bank_0



filler:
		ds	prog_end-filler
end
